#include <stdbool.h>

#include   "http.h"
#include "tcpbuf.h"
#include "action.h"
#include    "net.h"
#include    "log.h"
#include    "led.h"

bool HttpTrace = false;

void (*HttpReplyFunction  )(int todo);                                       //Plumb into this from your html server
int  (*HttpRequestFunction)(char *pPath, char *pLastModified, char *pQuery); //Plumb into this from your html server

void HttpHandleRequest(int size, char* pRequestStream, uint32_t positionInRequestStream, int* pToDo)
{
    if (HttpTrace)
    {
        LogF("HTTP  <<< %d (%u)\r\n", size, positionInRequestStream);
    }
    //Handle request for the first packet of data received but leave todo the same after that.
    if (size && positionInRequestStream == 0)
    {
        char* pMethod;
        char* pPath;
        char* pQuery;
        char* pLastModified;
        HttpReadRequest(pRequestStream, size, &pMethod, &pPath, &pQuery, &pLastModified);
        *pToDo = HttpRequestFunction(pPath, pLastModified, pQuery);
    }
    
}
void HttpSendReply(int* pSize, char* pReplyStream, uint32_t positionInReplyStream, uint16_t mss, int todo)
{
    TcpBufStart(positionInReplyStream, mss, pReplyStream);
    HttpReplyFunction(todo);
    *pSize = TcpBufLength();

    if (HttpTrace)
    {
        LogF("HTTP  >>> %d (%d)\r\n", *pSize, positionInReplyStream);
    }
}
